//VGA driver for Starblazer

#define _textmode 0x03
#define graphics 0x13
char *back;
char* numbers;
unsigned short defaultVGApalette[256];
unsigned short currentPalette[256];
char lineBuffer[320];

char* fuck;

void flipbuffer();

void lockBuffer(unsigned char* bits){
    int i;
    short* backbuffer = backBits;

    for(i = 0; i < 64000; i++){
        backbuffer[i] = currentPalette[bits[i]];
    }
}

void setVGApalette(){
    int i;

    /**for(i = 1; i < 256; i++){
        defaultVGApalette[i] = 65535;
    }**/
    defaultVGApalette[31] = 65535; //white
    defaultVGApalette[40] = 31744; //red
    defaultVGApalette[32] = 31; //blue
    defaultVGApalette[36] = 31775; //magenta
    defaultVGApalette[48] = 992; //green
    defaultVGApalette[51] = 1023; //cyan
    defaultVGApalette[44] = 32736; //yellow
    defaultVGApalette[52] = 1023; //cyan
    defaultVGApalette[1] = 16; //dark blue
    defaultVGApalette[12] = 32074;//20744;
    defaultVGApalette[15] = 65535; //white
    defaultVGApalette[3] = 693;
    defaultVGApalette[0x26] = 31760;
    defaultVGApalette[0x68] = 14;
    defaultVGApalette[2] = 672;
    defaultVGApalette[0x2f] = 31775;
    defaultVGApalette[0x56] = 9184;
    defaultVGApalette[0x40] = 9184;

}

void entermode(char mode){ //this function changes graphics modes
    setVGApalette();

    GDK_initialize(320, 200, 16, "Starblazer for Windows 95/NT");
    back = malloc(64000);
    memset(back, 0, 64000);
    memcpy(currentPalette, defaultVGApalette, 512);
}

void plotpixel(unsigned short x, unsigned short y, char color) { //this function plots a pixel into the back buffer
        if ((x < 320) && (y < 200)) {
                back[(y << 8) + (y << 6) + x] = color;
        }
}

void flipbuffer() {
        //flip lines
        int line = 0;

        for(; line < 100; line++){
            memcpy(lineBuffer, back + 320*(199-line), 320);
            memcpy(back + 320*(199-line), back + 320*line, 320);
            memcpy(back + 320*line, lineBuffer, 320);
        }

        //copy back buffer into front buffer
        lockBuffer(back);
        GDK_drawBits();
        //clear back buffer
        memset(back, 0, 64000);
}

void waitblank(){ //this function polls the VBlank register and won't return until retrace
        Sleep(10);
}

void blitmap(char* pixels, short x, short y, short lengthX, short lengthY) {
        int i, o;
        for (i = 0; i < lengthY; i++) {
                for (o = 0; o < lengthX; o++) {
                        if (pixels[lengthX * i + o]) {
                                plotpixel(x + o, y + i, 48);
                        }
                }
        }
}

void putscore(short num, short x, short y){
    //put four actual numbers

        //one's place
        blitmap(&numbers[num % 10 * 64], 24, 0, 8, 8);

        //ten's place
        blitmap(&numbers[((num % 100) - (num % 10))/10 * 64], 16, 0, 8, 8);

        //hundred's place
        blitmap(&numbers[((num % 1000) - (num % 100)) / 100 * 64], 8, 0, 8, 8);

        //thousand's place
        blitmap(&numbers[(num - (num % 1000)) / 1000 * 64], 0, 0, 8, 8);

        //put two "phantom" numbers after
        blitmap(numbers, 32, 0, 8, 8);
        blitmap(numbers, 40, 0, 8, 8);
}







